SystemOrganization addCategory: #'SleepyCoders-WalkieTalkie'!

Object subclass: #WalkieTalkie
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SleepyCoders-WalkieTalkie'!

!WalkieTalkie methodsFor: 'as yet unclassified' stamp: 'imy 4/16/2012 05:50'!
disconnect
	"If I'm paired disconnect me from my partner."

	(self paired) ifTrue: [
		session closeAndDestroy].! !

!WalkieTalkie methodsFor: 'initialization' stamp: 'imy 4/16/2012 02:39'!
initializeAsListenerOnIP: ip port: port
	[
		|socket|
		socket := Socket newTCP.
		[session isNil] whileTrue:
		[
			socket listenOn: port backlogSize: 50 interface: ip.
			session := socket waitForAcceptFor: 60.
			Processor yield.
		]
	] fork.! !

!WalkieTalkie methodsFor: 'initialization' stamp: 'YuriyTymchuk 4/16/2012 01:54'!
initializeAsTalkerToHost:host port: port
	session := Socket newTCP.
  	session connectToHostNamed: host port: port.! !

!WalkieTalkie methodsFor: 'status' stamp: 'YuriyTymchuk 4/16/2012 03:42'!
paired
"returns true if walkie is paird with another one. ei session ivar is set up"

	^(session isNil not) and: (session isConnected).! !

!WalkieTalkie methodsFor: 'I/O' stamp: 'YuriyTymchuk 4/16/2012 03:51'!
read
"reads data available on the walkie"
	
	(self unread) ifTrue:
	[
		^ReferenceStream unStream: session receiveData.
	].
	^nil.! !

!WalkieTalkie methodsFor: 'I/O' stamp: 'imy 4/16/2012 05:52'!
send: data
	"Send data to the other walkie"

	(self paired) ifTrue: [
		session sendSomeData: (ReferenceStream streamedRepresentationOf:  data)]! !

!WalkieTalkie methodsFor: 'status' stamp: 'YuriyTymchuk 4/16/2012 02:26'!
unread
"Returns true if walkie has unread data"

	^session dataAvailable.! !
